package com.rbevans;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet implementation class SetCookies
 */
@WebServlet("/SetCookies")
public class SetCookies extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public SetCookies() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		  response.setContentType("text/html;charset=ISO-8859-1");
	        PrintWriter out = response.getWriter();
	        try {
	   
	            out.println("<html>");
	            out.println("<head>");
	            out.println("<title>Servlet SetCookies</title>");  
	            out.println("</head>");
	            out.println("<body>");
	            out.println("<h1>Servlet SetCookies</h1>");
	            out.println("<p>As you first visit this page, you have the following cookies:</p>");
	            Cookie[] cookies = request.getCookies();
	            if (cookies != null) {
	                for (int i = 0; i < cookies.length; i++) {
	                    Cookie c = cookies[i];
	                    out.println("Cookie #" + i + " has a name of \"" + c.getName() +
	                              "\" and a value of \"" + c.getValue() + "\"<br>");
	                }
	            } else {
	                out.println("Sorry no cookes found at all...");
	            }
	            out.println("<br><br>");
	            out.println("Click <a href=\"SetCookies\">here</a> to reload the page and view the current cookies");
	            out.println("</body>");
	            out.println("</html>");
	            // add sessin cookie, no maxAge set
	            String pattern = "yyyy-MM-dd";
	            SimpleDateFormat simpleDateFormat = new SimpleDateFormat(pattern);
	            response.addCookie(new Cookie("en505681-updater-servlet-session", "Viewed"));
	            Cookie longLivedCookie = new Cookie("en505681-updater-servlet-page", "Viewed_at_" + 
	            		simpleDateFormat.format(new Date()));
	            longLivedCookie.setMaxAge(60*60);  // only an hour, we like 'em fresh
	            response.addCookie(longLivedCookie);
	        } finally { 
	            out.close();
	        }
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doGet(request, response);
	}

}
